package edu.rice.comp322;

import edu.rice.hj.runtime.config.HjSystemProperty;

import java.util.Arrays;

/**
 * This class should not be modified.
 *
 * @author <a href="http://shams.web.rice.edu/">Shams Imam</a> (shams@rice.edu)
 */
public final class SudokuMain {

    public static void main(final String[] args) {

        final String[] inputArgs = args.length == 0 ? new String[]{"-f", "src/main/resources/sudoku/36x36-1.txt", "-g", "1000", "-iter", "6"} : args;

        HjSystemProperty.numWorkers.set(8);
        final double[] parSearchResults8 = BenchmarkRunner.runBenchmark(inputArgs, new ParallelSearchBenchmark());
        final double[] parLexicalResults8 = BenchmarkRunner.runBenchmark(inputArgs, new ParallelLexicalBenchmark());

        HjSystemProperty.numWorkers.set(4);
        final double[] parSearchResults4 = BenchmarkRunner.runBenchmark(inputArgs, new ParallelSearchBenchmark());
        final double[] parLexicalResults4 = BenchmarkRunner.runBenchmark(inputArgs, new ParallelLexicalBenchmark());

        HjSystemProperty.numWorkers.set(1);
        final double[] parSearchResults1 = BenchmarkRunner.runBenchmark(inputArgs, new ParallelSearchBenchmark());
        final double[] parLexicalResults1 = BenchmarkRunner.runBenchmark(inputArgs, new ParallelLexicalBenchmark());

        HjSystemProperty.numWorkers.set(1);
        final double[] seqExecResults = BenchmarkRunner.runBenchmark(inputArgs, new SequentialBenchmark());

        System.out.println("------------------------------------------------------------------------");
        System.out.println("Input: " + Arrays.toString(inputArgs));
        System.out.println("-----------------------------------");
        System.out.printf(BenchmarkRunner.statDataOutputFormat, "[Sequential Baseline]", " Speedup Search-1", seqExecResults[0] / parSearchResults1[0]);
        System.out.printf(BenchmarkRunner.statDataOutputFormat, "[Sequential Baseline]", " Speedup Lexical-1", seqExecResults[0] / parLexicalResults1[0]);
        System.out.println("-----------------------------------");
        System.out.printf(BenchmarkRunner.statDataOutputFormat, "[Sequential Baseline]", " Speedup Search-4", seqExecResults[0] / parSearchResults4[0]);
        System.out.printf(BenchmarkRunner.statDataOutputFormat, "[Sequential Baseline]", " Speedup Lexical-4", seqExecResults[0] / parLexicalResults4[0]);
        System.out.println("-----------------------------------");
        System.out.printf(BenchmarkRunner.statDataOutputFormat, "[Sequential Baseline]", " Speedup Search-8", seqExecResults[0] / parSearchResults8[0]);
        System.out.printf(BenchmarkRunner.statDataOutputFormat, "[Sequential Baseline]", " Speedup Lexical-8", seqExecResults[0] / parLexicalResults8[0]);
        System.out.println("-----------------------------------");
        System.out.printf(BenchmarkRunner.statDataOutputFormat, "[Parallel-1 Baseline]", " Speedup Search-4", parSearchResults1[0] / parSearchResults4[0]);
        System.out.printf(BenchmarkRunner.statDataOutputFormat, "[Parallel-1 Baseline]", " Speedup Lexical-4", parLexicalResults1[0] / parLexicalResults4[0]);
        System.out.println("-----------------------------------");
        System.out.printf(BenchmarkRunner.statDataOutputFormat, "[Parallel-1 Baseline]", " Speedup Search-8", parSearchResults1[0] / parSearchResults8[0]);
        System.out.printf(BenchmarkRunner.statDataOutputFormat, "[Parallel-1 Baseline]", " Speedup Lexical-8", parLexicalResults1[0] / parLexicalResults8[0]);
        System.out.println("-----------------------------------");
        System.out.printf(BenchmarkRunner.statDataOutputFormat, "Nodes Explored", "Search-1", parSearchResults1[1]);
        System.out.printf(BenchmarkRunner.statDataOutputFormat, "Nodes Explored", "Lexical-1", parLexicalResults1[1]);
        System.out.println("-----------------------------------");
        System.out.printf(BenchmarkRunner.statDataOutputFormat, "Nodes Explored", "Search-4", parSearchResults4[1]);
        System.out.printf(BenchmarkRunner.statDataOutputFormat, "Nodes Explored", "Lexical-4", parLexicalResults4[1]);
        System.out.println("-----------------------------------");
        System.out.printf(BenchmarkRunner.statDataOutputFormat, "Nodes Explored", "Search-8", parSearchResults8[1]);
        System.out.printf(BenchmarkRunner.statDataOutputFormat, "Nodes Explored", "Lexical-8", parLexicalResults8[1]);
        System.out.println("-----------------------------------");
        System.out.println("------------------------------------------------------------------------");

    }

}
